﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace ORM03
{
    public class Program
    {
        static void Main(string[] args)
        {

            //User user = new User();
            //typeof(User).GetProperty("UserId").SetValue(user, 10, null);
            //Console.WriteLine(user.UserId);

            ToObject3();
        }
        static List<User> ToObject1()
        {
            SqlDataReader reader = null;
            List<User> list = new List<User>();
            while (reader.Read())
            {
                User user = new User();
                if (reader["UserId"] != null)
                    user.UserId = (int)reader["UserId"];

                if (reader["Email"] != null)
                    user.Email = (string)reader["Email"];

                if (reader["CreatedTime"] != null)
                    user.CreatedTime = (DateTime)reader["CreatedTime"];

                list.Add(user);
            }
            return list;
        }
        static List<User> ToObject2()
        {
            SqlDataReader reader = null;
            List<User> list = new List<User>();
            while (reader.Read())
            {
                User user = new User();
                if (reader[0] != DBNull.Value)
                    user.UserId = reader.GetInt32(0);

                if (reader[1] != DBNull.Value)
                    user.Email = reader.GetString(1);

                if (reader[2] != DBNull.Value)
                    user.CreatedTime = reader.GetDateTime(2);

                list.Add(user);
            }
            return list;
        }
        static void ToObject3()
        {
            string sql = "select * from tb_users";
            SqlConnection conn = new SqlConnection(EntityHelper.connectionString);
            conn.Open();

            var cmd = conn.CreateCommand();
            cmd.CommandText = sql;

            SqlDataReader reader = cmd.ExecuteReader();
            List<User> list = new List<User>();
            var type = typeof(User);
            var properties = type.GetProperties();
            while (reader.Read())
            {

                var user = Activator.CreateInstance(type);
                for (int i = 0; i < properties.Length; i++)
                {
                    var pi = properties[i];
                    if (reader[pi.Name] != null) //等同于 if (reader["UserId"] != null)这样的语句
                        pi.SetValue(user, reader[pi.Name], null); //等同于 user.UserId = (int)reader["UserId"];
                }

                list.Add((User)user);
            }

            foreach (var item in list)
            {
                Console.WriteLine("UserId:{0}，Email：{1}，CreatedTime：{2}", item.UserId, item.Email, item.CreatedTime);
            }
        }
        static List<T> GetEntityList<T>(string sql)
        {
            SqlConnection conn = new SqlConnection(EntityHelper.connectionString);
            conn.Open();

            var cmd = conn.CreateCommand();
            cmd.CommandText = sql;

            SqlDataReader reader = cmd.ExecuteReader();
            List<T> list = new List<T>();
            var type = typeof(T);
            var properties = type.GetProperties();
            while (reader.Read())
            {
                var user = Activator.CreateInstance(type);
                for (int i = 0; i < properties.Length; i++)
                {
                    var pi = properties[i];
                    if (reader[pi.Name] != null) //等同于 if (reader["UserId"] != null)这样的语句
                        pi.SetValue(user, reader[pi.Name], null); //等同于 user.UserId = (int)reader["UserId"];
                }

                list.Add((T)user);
            }
            return list;
        }
    }
}