﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ORM03
{
    [AttributeUsage(AttributeTargets.Class)]
    class TableAttribute : Attribute
    {
        /// <summary>
        /// 表名
        /// </summary>
        public string Name { get; private set; }

        public TableAttribute(string name)
        {
            this.Name = name;
        }
    }

    [AttributeUsage(AttributeTargets.Property)]
    class ColumnAttribute : Attribute
    {
        /// <summary>
        /// 是否为数据库自动生成
        /// </summary>
        public bool IsGenerated { get; set; }

        /// <summary>
        /// 列名
        /// </summary>
        public string Name { get; private set; }

        public ColumnAttribute(string name)
        {
            this.Name = name;
        }
    }
}